package com.gmei.data.dq

import org.apache.spark.sql.SparkSession
import org.apache.spark.{SparkConf, SparkContext}

/**
  * Created by pengfei.x on 2019/3/22.
  */
object Main {

  def main(args: Array[String]) = {
    val spark = SparkSession.builder()
      .enableHiveSupport()
      .config("spark.hive.mapred.supports.subdirectories","true")
      .config("spark.hadoop.mapreduce.input.fileinputformat.input.dir.recursive","true")
      .appName("DataQualityMonitor")
      .getOrCreate()

    // For implicit conversions like converting RDDs to DataFrames
    import spark.implicits._

    var partition_date = ""
    var yesterday = ""
    var cmd = ""

    if (args.length == 2 && Utils.is_date_string(args(0))) {
      partition_date = args(0)
      cmd = args(1)
    }
    else {
      throw new IllegalArgumentException("have no partition date!")
    }

    // check pv
    // pvReferCheker.check(spark, partition_date)
    if (cmd == "actionCheck") {
      actionCheck.check(spark, partition_date)
    } else if (cmd == "pvCheck") {
      pvChecker.check(spark, partition_date)
    } else {
      println("unknow cmd. supported actionCheck|pvCheck ")
    }
    spark.stop()
  }
}
