package com.gmei.data.dq

import java.sql.DriverManager
import java.text.SimpleDateFormat
import java.util.{Calendar, Date}

object Utils {

  def is_date_string(time_str: String): Boolean = {
    val dateFormat: SimpleDateFormat = new SimpleDateFormat("yyyyMMdd")
    try {
      val time_date = dateFormat.parse(time_str)
      if (dateFormat.format(time_date).equals(time_str) && time_str > "20100101" && time_str < "20500101")
        return true
      else
        return false
    }
    catch {
      case e: Exception =>
        return false
    }
  }

  def formatDateToString(date: Date, formatString: String = "yyyyMMdd"): String = {
    val dateFormat = new SimpleDateFormat(formatString)
    dateFormat.format(date)
  }

  def getDateByStringAndFormatStr(date: String, formatString: String = "yyyyMMdd") = {
    val dateFormat = new SimpleDateFormat(formatString)
    dateFormat.parse(date)
  }

  def getYesterday(date: Date) = {
    getNdaysBefore(date, 1)
  }

  def getYesterdayStr(date: Date, formatString: String = "yyyyMMdd") = {
    val d = getYesterday(date)
    formatDateToString(d, formatString)
  }

  def getYesterDayStrByTodayStr(today: String, formatString: String = "yyyyMMdd") = {
    val d = getDateByStringAndFormatStr(today, formatString)
    val i = getYesterday(d)
    formatDateToString(i, formatString)
  }

  def getNdaysBefore(date: Date, n: Int) = {
    val cal = Calendar.getInstance
    cal.setTime(date)
    cal.add(Calendar.DATE, 0 - n)
    cal.getTime
  }

  def getNdaysBeforeStr(date: Date, n: Int, formatString: String): String = {
    val i = getNdaysBefore(date, n)
    formatDateToString(i, formatString)
  }

  def getNdaysBeforeStr(date: String, n: Int, formatString: String): String = {
    val i = getDateByStringAndFormatStr(date, formatString)
    getNdaysBeforeStr(i, n, formatString)
  }

  def getTidbConnectionInfo() = {
    Class.forName("com.mysql.jdbc.Driver")

    val jdbcUsername = "root"
    val jdbcPassword = "3SYz54LS9#^9sBvC"

    val prop = new java.util.Properties()
    prop.put("user", jdbcUsername)
    prop.put("password", jdbcPassword)
    prop.put("driver", "com.mysql.jdbc.Driver")

    val url="jdbc:mysql://172.16.40.172:4000/jerry_test?useUnicode=true&characterEncoding=UTF-8&autoReconnect=true"

    // check connection
    val connection = DriverManager.getConnection(url, jdbcUsername, jdbcPassword)
    if (connection.isClosed())
      throw new Exception("db is not available!")

    (url, prop)
  }

}
