package com.gmei.data.dq

import org.apache.spark.sql.SaveMode
import org.apache.spark.sql.SparkSession

object actionCheck {

  def check(sc: SparkSession, partition_date: String) = {
    import sc.implicits._

    val yesterday = Utils.getYesterDayStrByTodayStr(partition_date)

    val df = sc.sql(
      s"""
        |select
        | a.partition_date as date,
        | b.partition_date as yesterday,
        | a.cl_type,
        | a.action,
        | a.c as todayCount,
        | b.c as yesterdayCount,
        | case when b.c = 0 then 1.0 else (a.c - b.c) * 1.0 / b.c end as chainRate
        |from
        |(
        | select partition_date, cl_type, action, count(1) as c
        | from online.bl_hdfs_maidian_updates
        | where partition_date = '${partition_date}'
        | group by partition_date, cl_type, action
        |) a left join (
        | select partition_date, cl_type, action, count(1) as c
        | from online.bl_hdfs_maidian_updates
        | where partition_date = '${yesterday}'
        | group by partition_date, cl_type, action
        |) b on a.cl_type = b.cl_type and a.action = b.action
      """.stripMargin)

    val tidb = Utils.getTidbConnectionInfo
    //df is a dataframe contains the data which you want to write.
    df.write.mode(SaveMode.Append).jdbc(tidb._1, "maidian_action_check", tidb._2)

    // TODO: delete date before 14 days ago
  }
}
